--選択範囲と文字列を取得
selected_pos=GetSelectedRange(-1)
select_text=GetSelectedText(-1)
next_pos = 1
out_text=""
repeat
	--{}で囲まれた部分を検索
	table_st,table_end = string.find(select_text, "(%b{})",next_pos)
	
	if table_end ~= nil then
		--{}を除いた部分を抽出
		table_text = string.sub(select_text,table_st+1,table_end-1);
		
		--開始文字から{までを出力
		out_text = out_text .. string.sub(select_text,next_pos,table_st)
		--}を次の開始文字にする
		next_pos = table_end
		--数値列から配列を作成
		data = {}
		tpos = 1
		while tpos <= string.len(table_text) do
			i,f,str = string.find(table_text, "(-?%d+)",tpos)
			if str ~= nil then
				tpos = f+1
				table.insert(data,tonumber(str))
			else
				tpos = string.len(table_text) + 1
			end
		end
		--数値列に対する処理を行う
		
		--最大値を取得
		max = 0
		for i=1,#data do
			if data[i] > max then
				max = data[i]
			end
		end
		--レンジを決定
		range = 1
		while range-1 < max do
			range = range * 2
		end
		range = range - 1
		
		--テーブルの長さを倍にする
		wavelet = {}
		for j=1, 2 do
			for i=1, #data do
				table.insert(wavelet,data[i])
			end
		end
		--窓掛けをする
		for i=1, #wavelet do
			wavelet[i] = wavelet[i] * (0.5 - 0.5*math.cos(6.2831853072*(i-1)/#wavelet))
		end
		--波形を伸張する
		cent = -100
		ratio = 2^(cent/1200)
		stride = 1/ratio
		strecthed_wavelet = {}
		srcpos = 1
		newlength = math.floor(#wavelet*ratio+0.5)
		for i=1, newlength do
			if srcpos<=#wavelet then
				prev = math.floor(srcpos)
				next = math.min(prev + 1,#wavelet)
				frac = srcpos - prev
				value = wavelet[prev] * (1-frac) + wavelet[next] * frac
				table.insert(strecthed_wavelet,value)
			else
				table.insert(strecthed_wavelet,wavelet[#wavelet])
			end
			
			srcpos = srcpos + stride
		end
		
		--３波長分オーバーラップさせて合成する
		newdata = {}
		max = 0
		halflen = math.floor(#strecthed_wavelet/2+0.5)
		for i=1, #data do
			wave = 0
			for j=-1, 1 do
				pos = i + halflen + (#data * j)
				if (pos >= 1) and (pos <= #strecthed_wavelet) then
					wave = wave + strecthed_wavelet[pos]
				end
			end
			--整数値に変換
			if wave > max then
				max = wave
			end
			table.insert(newdata, wave)
		end
		
		--ノーマライズする
		for i=1,#newdata do
			newdata[i] = math.floor(newdata[i] * (range / max) + 0.5)
		end
		
		--数値列を出力
		for i=1, #newdata do
			out_text = out_text .. tostring(newdata[i])
			if (i%16) == 0 then
				out_text = out_text .. '\r'
			else
				out_text = out_text .. '\t'
			end
		end
	else
		--{}が見つからなければ残りの文字を出力して終了
		out_text = out_text .. string.sub(select_text,next_pos)
		next_pos = selected_pos.e+1
	end
until next_pos > string.len(select_text)
InputText(-1,out_text)	--選択範囲を処理後のデータで置き換える
SetSelectedRange(-1,selected_pos.s,selected_pos.s+string.len(out_text))